/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Rdiff.xs. Do not edit this file, edit Rdiff.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Rdiff.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "librsync.h"

/* try to be compatible with older perls */
/* SvPV_nolen() macro first defined in 5.005_55 */
/* this is slow, not threadsafe, but works */
#include "patchlevel.h"
#if (PATCHLEVEL == 4) || ((PATCHLEVEL == 5) && (SUBVERSION < 55))
static STRLEN nolen_na;
# define SvPV_nolen(sv) SvPV ((sv), nolen_na)
#endif

static SV *trace_cb_sv;

typedef rs_stats_t *	File__Rdiff__Stats;
typedef rs_signature_t *File__Rdiff__Signature;

typedef struct File__Rdiff__Buffers {
  rs_buffers_t rs;
  SV *in;
  STRLEN in_ofs;
  SV *out;
  STRLEN outsize;
} *File__Rdiff__Buffers;

typedef struct File__Rdiff__Job {
  rs_job_t *rs;
  SV *sig;
} *File__Rdiff__Job;

static SV *new_sig (File__Rdiff__Signature sig)
{
  SV *sv = NEWSV (0, 0);
  sv_setref_pv (sv, "File::Rdiff::Signature", (void *)sig);

  return sv;
}

static File__Rdiff__Signature
old_sig (SV *sv)
{
  if (sv_derived_from(sv, "File::Rdiff::Signature"))
    {
      IV tmp = SvIV((SV*)SvRV(sv));
      return INT2PTR(rs_signature_t *,tmp);
    }
  else
    Perl_croak(aTHX_ "Object of type File::Rdiff::Signature expected");
}

static void
trace_cb (int level, char const *msg)
{
  if (SvOK (trace_cb_sv))
    {
      dSP;
      
      SAVETMPS; PUSHMARK(SP); EXTEND(SP,2);

      PUSHs(sv_2mortal(newSViv(level)));
      PUSHs(sv_2mortal(newSVpv(msg,0)));

      PUTBACK; perl_call_sv (trace_cb_sv, G_VOID|G_DISCARD); SPAGAIN;

      PUTBACK; FREETMPS;
    }
  else
    rs_trace_stderr (level, msg);
}

/**
 * \brief Callback used to retrieve parts of the basis file.
 *
 * \param pos Position where copying should begin.
 *
 * \param len On input, the amount of data that should be retrieved.
 * Updated to show how much is actually available.
 *
 * \param buf On input, a buffer of at least \p *len bytes.  May be
 * updated to point to a buffer allocated by the callback if it
 * prefers.
 */
static rs_result
copy_cb (void *cb, rs_long_t pos, size_t *len, void **buf)
{
  dSP;
  SV *rbuf;
  
  PUSHMARK(SP); EXTEND(SP,2);

  PUSHs(sv_2mortal(newSViv(pos)));
  PUSHs(sv_2mortal(newSViv(*len)));

  PUTBACK; perl_call_sv ((SV *)cb, G_SCALAR); SPAGAIN;

  rbuf = POPs;

  PUTBACK;

  if (SvIOKp (rbuf) && !SvPOKp (rbuf))
    {
      /* assume error code */
      return SvIVX (rbuf);
    }
  else
    {
      /* assume data. we are not copying because we assume
       * that the data will be consumed before the next FREETMPS,
       * which should be just outside ther rs_job_iter call.
       */
      STRLEN slen;

      *buf = SvPV (rbuf, slen);
      *len = slen;

      return RS_DONE;
    }
}

#line 133 "Rdiff.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 277 "Rdiff.c"

XS_EUPXS(XS_File__Rdiff_trace_level); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_trace_level)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "level");
    {
	int	level = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 166 "Rdiff.xs"
        static int oldlevel = RS_LOG_WARNING; /* see BOOT: */

        RETVAL = oldlevel;
        if (items)
          {
            oldlevel = level;
            rs_trace_set_level (level);
          }
#line 299 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff_trace_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_trace_to)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	SV *	cb = ST(0)
;
	SV *	RETVAL;
#line 182 "Rdiff.xs"
        RETVAL = sv_2mortal (newSVsv (trace_cb_sv));
        if (items)
          sv_setsv (trace_cb_sv, cb);
#line 320 "Rdiff.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff_supports_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_supports_trace)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 192 "Rdiff.xs"
        if (rs_supports_trace())
          XSRETURN_YES;
        else
          XSRETURN_NO;
#line 340 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_strerror)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "resultcode");
    {
	int	resultcode = (int)SvIV(ST(0))
;
	SV *	RETVAL;
#line 201 "Rdiff.xs"
        RETVAL = newSVpv (rs_strerror (resultcode), 0);
#line 358 "Rdiff.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Signature_build_hash_table); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Signature_build_hash_table)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Signature	self = old_sig (ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 211 "Rdiff.xs"
        RETVAL = rs_build_hash_table (self);
#line 379 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Signature_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Signature_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Signature	self = old_sig (ST(0))
;
#line 219 "Rdiff.xs"
        rs_free_sumset (self);
#line 397 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff__Signature_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Signature_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Signature	self = old_sig (ST(0))
;
#line 225 "Rdiff.xs"
        rs_sumset_dump (self);
#line 414 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff__Buffers_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, outsize = 65536");
    {
	SV *	class = ST(0)
;
	STRLEN	outsize;
	File__Rdiff__Buffers	RETVAL;

	if (items < 2)
	    outsize = 65536;
	else {
	    outsize = (STRLEN)SvUV(ST(1))
;
	}
#line 235 "Rdiff.xs"
        Newz (0, RETVAL, 1, struct File__Rdiff__Buffers);
        RETVAL->outsize = outsize;
#line 441 "Rdiff.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "File::Rdiff::Buffers", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Buffers_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Buffers	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"File::Rdiff::Buffers::DESTROY",
			"self")
;
#line 244 "Rdiff.xs"
        if (self->in ) SvREFCNT_dec (self->in );
        if (self->out) SvREFCNT_dec (self->out);
        Safefree (self);
#line 475 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff__Buffers_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_in)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, in");
    {
	File__Rdiff__Buffers	self;
	SV *	in = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Buffers::in",
			"self", "File::Rdiff::Buffers")
;
#line 253 "Rdiff.xs"
        if (self->in)
          SvREFCNT_dec (self->in);
        self->in = SvREFCNT_inc (in);
        self->in_ofs = 0;
#line 506 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff__Buffers_eof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_eof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Buffers	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Buffers::eof",
			"self", "File::Rdiff::Buffers")
;
#line 262 "Rdiff.xs"
        self->rs.eof_in = 1;
#line 532 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff__Buffers_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_out)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Buffers	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Buffers::out",
			"self", "File::Rdiff::Buffers")
;
#line 268 "Rdiff.xs"
        RETVAL = self->out;
        self->out = 0;
#line 560 "Rdiff.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Buffers_avail_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_avail_in)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Buffers	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Buffers::avail_in",
			"self", "File::Rdiff::Buffers")
;
#line 277 "Rdiff.xs"
        RETVAL = self->in ? SvCUR (self->in) - self->in_ofs
                          : self->rs.eof_in ? -1
                                            : 0;
#line 592 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Buffers_avail_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_avail_out)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Buffers	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Buffers::avail_out",
			"self", "File::Rdiff::Buffers")
;
#line 287 "Rdiff.xs"
        RETVAL = self->outsize - (self->out ? SvCUR (self->out) : 0);
#line 621 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Buffers_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Buffers_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Buffers	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Buffers::size",
			"self", "File::Rdiff::Buffers")
;
#line 295 "Rdiff.xs"
        RETVAL = self->out ? SvCUR (self->out) : 0;
#line 650 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Job_new_sig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_new_sig)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "class, new_block_len = RS_DEFAULT_BLOCK_LEN, strong_sum_len = RS_DEFAULT_STRONG_LEN");
    {
	SV *	class = ST(0)
;
	size_t	new_block_len;
	size_t	strong_sum_len;
	File__Rdiff__Job	RETVAL;

	if (items < 2)
	    new_block_len = RS_DEFAULT_BLOCK_LEN;
	else {
	    new_block_len = (size_t)SvUV(ST(1))
;
	}

	if (items < 3)
	    strong_sum_len = RS_DEFAULT_STRONG_LEN;
	else {
	    strong_sum_len = (size_t)SvUV(ST(2))
;
	}
#line 308 "Rdiff.xs"
        Newz (0, RETVAL, 1, struct File__Rdiff__Job);
        RETVAL->rs = rs_sig_begin (new_block_len, strong_sum_len);
#line 686 "Rdiff.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "File::Rdiff::Job", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Job_new_loadsig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_new_loadsig)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
	File__Rdiff__Job	RETVAL;
#line 317 "Rdiff.xs"
        rs_signature_t *sig;
        Newz (0, RETVAL, 1, struct File__Rdiff__Job);
        RETVAL->rs = rs_loadsig_begin (&sig);
        RETVAL->sig = new_sig (sig);
#line 713 "Rdiff.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "File::Rdiff::Job", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Job_new_delta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_new_delta)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, signature");
    {
	SV *	class = ST(0)
;
	SV *	signature = ST(1)
;
	File__Rdiff__Job	RETVAL;
#line 329 "Rdiff.xs"
        Newz (0, RETVAL, 1, struct File__Rdiff__Job);
        RETVAL->rs = rs_delta_begin (old_sig (signature));
        RETVAL->sig = newSVsv (signature);
#line 741 "Rdiff.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "File::Rdiff::Job", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Job_new_patch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_new_patch)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, cb_or_fh");
    {
	SV *	class = ST(0)
;
	SV *	cb_or_fh = ST(1)
;
	File__Rdiff__Job	RETVAL;
#line 340 "Rdiff.xs"
        rs_copy_cb *cb;
        void *cb_arg;

        if (SvROK (cb_or_fh) && SvTYPE (SvRV (cb_or_fh)) == SVt_PVCV)
          {
            cb = copy_cb;
            cb_arg = (void *)cb_or_fh;
          }
        else
          {
            cb = rs_file_copy_cb;
            cb_arg = (void *)IoIFP (sv_2io (cb_or_fh));
          }

        Newz (0, RETVAL, 1, struct File__Rdiff__Job);
        RETVAL->rs = rs_patch_begin (cb, cb_arg);
#line 782 "Rdiff.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "File::Rdiff::Job", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Job_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Job	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Job,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"File::Rdiff::Job::DESTROY",
			"self")
;
#line 363 "Rdiff.xs"
        if (self->sig)
          SvREFCNT_dec (self->sig);
        rs_job_free (self->rs);
        Safefree (self);
#line 817 "Rdiff.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_File__Rdiff__Job_signature); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_signature)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	File__Rdiff__Job	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Job")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Job,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Job::signature",
			"self", "File::Rdiff::Job")
;
#line 372 "Rdiff.xs"
        RETVAL = SvREFCNT_inc (self->sig);
#line 844 "Rdiff.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff__Job_iter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff__Job_iter)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, buffers");
    {
	File__Rdiff__Job	self;
	File__Rdiff__Buffers	buffers;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "File::Rdiff::Job")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(File__Rdiff__Job,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Job::iter",
			"self", "File::Rdiff::Job")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "File::Rdiff::Buffers")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    buffers = INT2PTR(File__Rdiff__Buffers,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"File::Rdiff::Job::iter",
			"buffers", "File::Rdiff::Buffers")
;
#line 381 "Rdiff.xs"
{
        STRLEN in_len;

        if (buffers->in)
          {
            buffers->rs.next_in = SvPV (buffers->in, in_len) + buffers->in_ofs;
            buffers->rs.avail_in = in_len - buffers->in_ofs;
          }
        else
          {
            buffers->rs.next_in = 0;
            buffers->rs.avail_in = 0;
          }

        if (buffers->outsize)
          {
            if (!buffers->out)
              {
                buffers->out = NEWSV (0, buffers->outsize);
                SvPOK_on (buffers->out);
              }

            buffers->rs.next_out = SvEND (buffers->out);
            buffers->rs.avail_out = buffers->outsize - SvCUR (buffers->out);
          }
        else
          {
            buffers->rs.next_out = 0;
            buffers->rs.avail_out = 0;
          }

        RETVAL = rs_job_iter (self->rs, &buffers->rs);

        buffers->in_ofs = in_len - buffers->rs.avail_in;

        if (buffers->out)
          SvCUR_set (buffers->out, buffers->outsize - buffers->rs.avail_out);
}
#line 922 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifndef RSYNC_NO_STDIO_INTERFACE
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_File__Rdiff_sig_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_sig_file)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "old_file, sig_file, block_len = RS_DEFAULT_BLOCK_LEN, strong_len = RS_DEFAULT_STRONG_LEN");
    {
	FILE *	old_file = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	FILE *	sig_file = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	size_t	block_len;
	size_t	strong_len;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    block_len = RS_DEFAULT_BLOCK_LEN;
	else {
	    block_len = (size_t)SvUV(ST(2))
;
	}

	if (items < 4)
	    strong_len = RS_DEFAULT_STRONG_LEN;
	else {
	    strong_len = (size_t)SvUV(ST(3))
;
	}
#line 469 "Rdiff.xs"
        RETVAL = rs_sig_file(old_file, sig_file, block_len, strong_len, 0); 
#line 963 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff_loadsig_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_loadsig_file)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "file");
    {
	FILE *	file = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	File__Rdiff__Signature	RETVAL;
#line 477 "Rdiff.xs"
        rs_result r = rs_loadsig_file(file, &RETVAL, 0);
        if (r != RS_DONE)
          XSRETURN_IV (r);
#line 984 "Rdiff.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv (RETVALSV, "File::Rdiff::Signature", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff_delta_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_delta_file)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "signature, new_file, delta_file");
    {
	File__Rdiff__Signature	signature = old_sig (ST(0))
;
	FILE *	new_file = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	FILE *	delta_file = PerlIO_findFILE(IoIFP(sv_2io(ST(2))))
;
	int	RETVAL;
	dXSTARG;
#line 489 "Rdiff.xs"
        RETVAL = rs_delta_file (signature, new_file, delta_file, 0);
#line 1013 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_File__Rdiff_patch_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_File__Rdiff_patch_file)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "basis_file, delta_file, new_file");
    {
	FILE *	basis_file = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	FILE *	delta_file = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	FILE *	new_file = PerlIO_findFILE(IoIFP(sv_2io(ST(2))))
;
	int	RETVAL;
	dXSTARG;
#line 499 "Rdiff.xs"
        RETVAL = rs_patch_file (basis_file, delta_file, new_file, 0);
#line 1037 "Rdiff.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_File__Rdiff); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_File__Rdiff)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("File::Rdiff::trace_level", XS_File__Rdiff_trace_level, file, ";$");
        (void)newXSproto_portable("File::Rdiff::trace_to", XS_File__Rdiff_trace_to, file, ";&");
        (void)newXSproto_portable("File::Rdiff::supports_trace", XS_File__Rdiff_supports_trace, file, "");
        (void)newXSproto_portable("File::Rdiff::strerror", XS_File__Rdiff_strerror, file, "$");
        (void)newXSproto_portable("File::Rdiff::Signature::build_hash_table", XS_File__Rdiff__Signature_build_hash_table, file, "$");
        (void)newXSproto_portable("File::Rdiff::Signature::DESTROY", XS_File__Rdiff__Signature_DESTROY, file, "$");
        (void)newXSproto_portable("File::Rdiff::Signature::dump", XS_File__Rdiff__Signature_dump, file, "$");
        (void)newXSproto_portable("File::Rdiff::Buffers::new", XS_File__Rdiff__Buffers_new, file, "$;$$");
        (void)newXSproto_portable("File::Rdiff::Buffers::DESTROY", XS_File__Rdiff__Buffers_DESTROY, file, "$");
        (void)newXSproto_portable("File::Rdiff::Buffers::in", XS_File__Rdiff__Buffers_in, file, "$$");
        (void)newXSproto_portable("File::Rdiff::Buffers::eof", XS_File__Rdiff__Buffers_eof, file, "$");
        (void)newXSproto_portable("File::Rdiff::Buffers::out", XS_File__Rdiff__Buffers_out, file, "$");
        (void)newXSproto_portable("File::Rdiff::Buffers::avail_in", XS_File__Rdiff__Buffers_avail_in, file, "$");
        (void)newXSproto_portable("File::Rdiff::Buffers::avail_out", XS_File__Rdiff__Buffers_avail_out, file, "$");
        (void)newXSproto_portable("File::Rdiff::Buffers::size", XS_File__Rdiff__Buffers_size, file, "$");
        (void)newXSproto_portable("File::Rdiff::Job::new_sig", XS_File__Rdiff__Job_new_sig, file, "$;$$");
        (void)newXSproto_portable("File::Rdiff::Job::new_loadsig", XS_File__Rdiff__Job_new_loadsig, file, "$");
        (void)newXSproto_portable("File::Rdiff::Job::new_delta", XS_File__Rdiff__Job_new_delta, file, "$$");
        (void)newXSproto_portable("File::Rdiff::Job::new_patch", XS_File__Rdiff__Job_new_patch, file, "$$");
        (void)newXSproto_portable("File::Rdiff::Job::DESTROY", XS_File__Rdiff__Job_DESTROY, file, "$");
        (void)newXSproto_portable("File::Rdiff::Job::signature", XS_File__Rdiff__Job_signature, file, "$");
        (void)newXSproto_portable("File::Rdiff::Job::iter", XS_File__Rdiff__Job_iter, file, "$$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("File::Rdiff::sig_file", XS_File__Rdiff_sig_file, file, "$$;$$");
        (void)newXSproto_portable("File::Rdiff::loadsig_file", XS_File__Rdiff_loadsig_file, file, "$");
        (void)newXSproto_portable("File::Rdiff::delta_file", XS_File__Rdiff_delta_file, file, "$$$");
        (void)newXSproto_portable("File::Rdiff::patch_file", XS_File__Rdiff_patch_file, file, "$$$");
#endif

    /* Initialisation Section */

#line 128 "Rdiff.xs"
{
	HV * stash = gv_stashpv ("File::Rdiff", 0);

        trace_cb_sv = newSVsv (&PL_sv_undef);

        rs_trace_to (trace_cb);
        rs_trace_set_level (RS_LOG_WARNING);

	newCONSTSUB (stash, "LIBRSYNC_VERSION",  newSVpv (rs_librsync_version, 0));

	newCONSTSUB (stash, "LOG_EMERG", newSViv (RS_LOG_EMERG));
	newCONSTSUB (stash, "LOG_ALERT", newSViv (RS_LOG_ALERT));
	newCONSTSUB (stash, "LOG_CRIT", newSViv (RS_LOG_CRIT));
	newCONSTSUB (stash, "LOG_ERR", newSViv (RS_LOG_ERR));
	newCONSTSUB (stash, "LOG_WARNING", newSViv (RS_LOG_WARNING));
	newCONSTSUB (stash, "LOG_NOTICE", newSViv (RS_LOG_NOTICE));
	newCONSTSUB (stash, "LOG_INFO", newSViv (RS_LOG_INFO));
	newCONSTSUB (stash, "LOG_DEBUG", newSViv (RS_LOG_DEBUG));
	newCONSTSUB (stash, "DONE", newSViv (RS_DONE));
	newCONSTSUB (stash, "BLOCKED", newSViv (RS_BLOCKED));
	newCONSTSUB (stash, "RUNNING", newSViv (RS_RUNNING));
	newCONSTSUB (stash, "TEST_SKIPPED", newSViv (RS_TEST_SKIPPED));
	newCONSTSUB (stash, "IO_ERROR", newSViv (RS_IO_ERROR));
	newCONSTSUB (stash, "SYNTAX_ERROR", newSViv (RS_SYNTAX_ERROR));
	newCONSTSUB (stash, "MEM_ERROR", newSViv (RS_MEM_ERROR));
	newCONSTSUB (stash, "INPUT_ENDED", newSViv (RS_INPUT_ENDED));
	newCONSTSUB (stash, "BAD_MAGIC", newSViv (RS_BAD_MAGIC));
	newCONSTSUB (stash, "UNIMPLEMENTED", newSViv (RS_UNIMPLEMENTED));
	newCONSTSUB (stash, "CORRUPT", newSViv (RS_CORRUPT));
	newCONSTSUB (stash, "INTERNAL_ERROR", newSViv (RS_INTERNAL_ERROR));
	newCONSTSUB (stash, "PARAM_ERROR", newSViv (RS_PARAM_ERROR));
}

#if XSubPPtmpAAAA
#endif
#line 1139 "Rdiff.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

